## meganz-sdk-v4.31.0b.tar.gz

=== CMakeLists.txt ===
# This file is here in the root folder so it can be opened as a CMake project in Visual Studio, eg in order to debug a Linux build in WSL2.
cmake_minimum_required(VERSION 3.13)
project(TryWSL)
include(${CMAKE_CURRENT_LIST_DIR}/contrib/cmake/CMakeLists.txt)

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         = a4
SOURCEDIR     = doc/source
BUILDDIR      = doc/_build
DOXYGEN       = doxygen
DOXYGENCFG    = doc/sphinx_doxy.cfg
DOXYGENDIR    = doc/sphinx_api

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) $(SOURCEDIR)
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) $(SOURCEDIR)

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext doxygen

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  doxygen    to build the XML documentation from sources using Doxygen"

clean:
	-rm -rf $(BUILDDIR)/* $(DOXYGENDIR)/*

html: doxygen
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml: doxygen
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml: doxygen
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle: doxygen
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json: doxygen
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp: doxygen
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp: doxygen
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/MEGAClientSDK.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/MEGAClientSDK.qhc"

devhelp: doxygen
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/MEGAClientSDK"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/MEGAClientSDK"
	@echo "# devhelp"

epub: doxygen
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex: doxygen
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf: doxygen
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text: doxygen
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man: doxygen
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo: doxygen
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info: doxygen
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext: doxygen
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes: doxygen
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck: doxygen
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest: doxygen
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

doxygen:
	$(DOXYGEN) $(DOXYGENCFG)

=== contrib/cmake/CMakeLists.txt ===
# This file enables building with cmake
#
# use cases
#  - generate a visual studio solution and projects, eg: cmake . -G "Visual Studio 15 2017"
#  - or for 64 bit: cmake . -G "Visual Studio 15 2017 Win64"
#  - or set your build options before VS project generation by using the gui, eg:  cmake-gui.exe .
#  - you can set up to build both 32 bit and 64 bit this way:
#       make subfolders '32' and '64' of this cmake folder
#       execute 'cmake-gui  ..' in each.  Select the cmake folder as the 'source code' folder, and the appropriate 32 or 64 folder as 'where to build the binaries' folder
#       for each cmake-gui configuration, choose the suitable 32/64 bit compiler, and corresponding setting for the build_64_bit variable.
#       then Configure, Generate, Open Project (all buttons in the gui) for each.

# check the ./build3rdParty.cmd script in this folder for how to (relatively) easily build the dependencies, typically in a 3rdParty folder outside of the SDK repo.

if (WIN32)
  cmake_minimum_required(VERSION 3.15)
  cmake_policy(SET CMP0091 NEW)   # for msvc dll/stsatic target
else()
  cmake_minimum_required(VERSION 3.13)
  set(CMAKE_EXPORT_COMPILE_COMMANDS ON) # Useful for make or ninja
  message( "CMAKE_EXPORT_COMPILE_COMMANDS ON")
endif()

project(MegaSDK)

set( CMAKE_EXPORT_COMPILE_COMMANDS ON) # Generates compile_commands.json with the compilers calls for all translations units
set (Mega3rdPartyDir "" CACHE FILEPATH "Prefix path for where third party dependencies are located")

if (CMAKE_HOST_APPLE AND NOT IOS)
    set (USE_OPENSSL 0 CACHE STRING "")
else()
    set (USE_OPENSSL 1 CACHE STRING "Usually Needed")
endif()

set (USE_ASIO 1 CACHE STRING "Only needed For tcprelay test tool")
set (USE_CURL 1 CACHE STRING "Always needed (turning it off would mean using WinHTTP instead but that has not been maintained for a while)")
set (USE_SQLITE 1 CACHE STRING "Needed unless intending a cache-less app")
set (USE_MEDIAINFO 1 CACHE STRING "Used to determine media properties and set those as node attributes")
set (USE_FREEIMAGE 1 CACHE STRING "Used to create previews/thumbnails for photos/pictures")
set (ENABLE_SYNC 1 CACHE STRING "Turns on sync functionality")
set (ENABLE_CHAT 0 CACHE STRING "Turns on chat management functionality")
set (ENABLE_LOG_PERFORMANCE 0 CACHE STRING "Faster log message generation")
set (HAVE_FFMPEG 1 CACHE STRING "Used to create previews/thumbnails for video files")
set (USE_WEBRTC 0 CACHE STRING "Declare that your app will link with WebRTC")
set (USE_LIBUV 0 CACHE STRING "Includes the library and turns on internal web and ftp server functionality")
set (USE_QT 0 CACHE STRING "Declare that your app will link wtih Qt")
set (USE_PDFIUM 1 CACHE STRING "Used to create previews/thumbnails for PDF files")
set (USE_LIBRAW 0 CACHE STRING "Just includes the library (used by MEGAsync)")
set (USE_PCRE 0 CACHE STRING "Can be used by client apps. The SDK does not use it itself anymore")
set (USE_DRIVE_NOTIFICATIONS 0 CACHE STRING "Allows to monitor (external) drives being [dis]connected to the computer")
set (MEGA_USE_C_ARES 1 CACHE STRING "If set, the SDK will manage DNS lookups and ipv4/ipv6 itself, using the c-ares library.  Otherwise we rely on cURL")
set (MEGA_QT_VERSION 5.12.11 CACHE STRING "Qt version installed in c:/Qt")

if (USE_PTHREAD)
    set( USE_CPPTHREAD 0)
else()
    set( USE_CPPTHREAD 1)
endif()

# Sodium is no longer optional. Setting the variable here to saisfy existing preprocessor checks and #cmakedefine
set (USE_SODIUM 1)

# Cryptop never was optional
set (USE_CRYPTOPP 1)

set (HAVE_LIBUV ${USE_LIBUV})
set (HAVE_LIBRAW ${USE_LIBRAW})

option(USE_THIRDPARTY_FROM_VCPKG
"Whether to look for third party dependencies in a vcpkg install. If yes, Mega3rdPartyDir must be a path to a directory containing the vcpkg directory"
${WIN32})

option(USE_QT_FROM_VCPKG
"Whether to look for QT dependencies in a vcpkg install. To set yes, USE_THIRDPARTY_FROM_VCPKG must be yes"
0)

if (NOT USE_THIRDPARTY_FROM_VCPKG AND USE_QT_FROM_VCPKG)
    message( WARNING "USE_THIRDPARTY_FROM_VCPKG is not set, turn off USE_QT_FROM_VCPKG" )
    set (USE_QT_FROM_VCPKG 0)
endif()

message(STATUS " Using 3rd party from vcpkg = ${USE_THIRDPARTY_FROM_VCPKG}")
message(STATUS " Using QT from vcpkg = ${USE_QT_FROM_VCPKG}")
message(STATUS " CMAKE_SYSTEM_NAME = ${CMAKE_SYSTEM_NAME}")

if(WIN32 OR IOS)
    set(NO_READLINE 1 CACHE STRING "")
else()
    set(NO_READLINE 0 CACHE STRING "")
endif()

if (WIN32)
    set (UNCHECKED_ITERATORS 0 CACHE STRING "")
    IF (USE_WEBRTC)
        IF ("${WebRtcDir}" STREQUAL "")
            SET (WebRtcDir "${Mega3rdPartyDir}/libwebrtc/build32debug")
        ENDIF()
    ENDIF()
endif()

if (USE_WEBRTC)
    if ("${WebRtcDir}" STREQUAL "")
        SET(WebRtcDir ${Mega3rdPartyDir}/libwebrtc/build32debug)
    endif()
endif()

set (MEGA_LINK_DYNAMIC_CRT 1 CACHE STRING "")

if (WIN32)
    message(STATUS "CMAKE_GENERATOR is ${CMAKE_GENERATOR}")
    message(STATUS "CMAKE_GENERATOR_PLATFORM is ${CMAKE_GENERATOR_PLATFORM}")
    if (("${CMAKE_GENERATOR_PLATFORM}" MATCHES "(Win64|IA64|x64)") OR
        ("${CMAKE_GENERATOR}" MATCHES "(Win64|IA64|x64)"))
        SET(build_64_bit 1)
        message(STATUS "Building 64 bit")
    elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
        SET(build_64_bit 0)
        message(STATUS "Building 32 bit")
    elseif("${CMAKE_CXX_COMPILER}" MATCHES "x64/cl.exe" )
        SET(build_64_bit 1)
        message(STATUS "Building 64 bit")
    elseif("${CMAKE_CXX_COMPILER}" MATCHES "x86/cl.exe" )
        SET(build_64_bit 0)
        message(STATUS "Building 32 bit")
    else()
        message(STATUS "CMAKE_SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P}")
        message(STATUS "CMAKE_CXX_COMPILER ${CMAKE_CXX_COMPILER}")
        message(FATAL_ERROR "Can't tell if we should build 32 bit or 64 bit")
    endif()
elseif(APPLE AND NOT IOS)
    set (build_64_bit 1)

    if (CMAKE_OSX_ARCHITECTURES MATCHES "arm64" OR (NOT CMAKE_OSX_ARCHITECTURES AND CMAKE_SYSTEM_PROCESSOR STREQUAL "arm64"))
        set(build_arm64 1)
        message("Building for macOS arm64 in a ${CMAKE_HOST_SYSTEM_PROCESSOR} host.")
    else()
        set(build_arm64 0)
        message("Building for macOS x86_64 in a ${CMAKE_HOST_SYSTEM_PROCESSOR} host.")
    endif()

else()
    set (build_64_bit 1 CACHE STRING "Build for a 64 bit target")
    message(STATUS "Building 64 bit")
endif()

if(APPLE AND NOT IOS)
    if(NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS "15.0")
        message("Building with ${CMAKE_CXX_COMPILER_ID} with version ${CMAKE_CXX_COMPILER_VERSION}")
        add_link_options("-Wl,-ld_classic")
    endif()
endif()


if(APPLE)
    set(CMAKE_CXX_STANDARD 11)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()

if ("${MEGA_PROJECT_NAME}" STREQUAL "")
    set(MEGA_PROJECT_NAME "MegaSDK" CACHE STRING "")
endif()

if(build_64_bit)
    project ("${MEGA_PROJECT_NAME}64" LANGUAGES CXX C)
else(build_64_bit)
    project ("${MEGA_PROJECT_NAME}32" LANGUAGES CXX C)
endif(build_64_bit)

IF(WIN32)
    set(MegaDir "${CMAKE_CURRENT_LIST_DIR}/../..")
    if ("${Mega3rdPartyDir}" STREQUAL "")
        set(Mega3rdPartyDir "${MegaDir}/../3rdParty" CACHE STRING "")
    endif()
ELSE(WIN32)
    set(MegaDir "${CMAKE_CURRENT_LIST_DIR}/../..")
    if ("${Mega3rdPartyDir}" STREQUAL "")
        set (Mega3rdPartyDir "${MegaDir}/../3rdParty/" CACHE STRING "")
    endif()
ENDIF(WIN32)

# currently supported scenarios for getting 3rd party libraries:
#  - vcpkg built dependencies (there are some scripts in this folder to build those)
#  - libraries from the system, installed via eg. apt-get on linux

if (USE_THIRDPARTY_FROM_VCPKG) #vcpkg or system

    #determine VCPKG triplet
    if(NOT VCPKG_TRIPLET)
        IF(WIN32)
            if (UNCHECKED_ITERATORS)
                if(build_64_bit)
                    set(VCPKG_TRIPLET "x64-windows-mega-uncheckediterators" CACHE STRING "")
                else(build_64_bit)
                    set(VCPKG_TRIPLET "x86-windows-mega-uncheckediterators" CACHE STRING "")
                endif(build_64_bit)
            else()
                if(build_64_bit)
                    set(VCPKG_TRIPLET "x64-windows-mega" CACHE STRING "")
                else(build_64_bit)
                    set(VCPKG_TRIPLET "x86-windows-mega" CACHE STRING "")
                endif(build_64_bit)
            endif()
        ELSEIF(CMAKE_HOST_APPLE)
            if(NOT IOS)
                if(build_arm64)
                    set(VCPKG_TRIPLET "arm64-osx-mega" CACHE STRING "")
                else()
                    set(VCPKG_TRIPLET "x64-osx-mega" CACHE STRING "")
                endif()
            else()
                set(VCPKG_TRIPLET "arm64-ios" CACHE STRING "")
            endif()
        ELSE()
            set(VCPKG_TRIPLET "x64-linux" CACHE STRING "")
        ENDIF()
    endif()


    set(vcpkg_dir "${Mega3rdPartyDir}/vcpkg/installed/${VCPKG_TRIPLET}")
endif()

message(STATUS, " Mega3rdPartyDir = ${Mega3rdPartyDir}")
message(STATUS, " USE_THIRDPARTY_FROM_VCPKG = ${USE_THIRDPARTY_FROM_VCPKG}")
message(STATUS, " vcpkg_dir = ${vcpkg_dir}")

# Since we offer some Qt support in the SDK, set up those dependencies here
# setup QT_DIR, qt_cmake_dir, qt_qmake_dir
# USE_QT_FROM_VCPKG override USE_QT
if (USE_QT_FROM_VCPKG)
    set(QT_DIR "${vcpkg_dir}/tools/qt5" CACHE STRING "Specify your QT install folder if it is nonstandard")
    set(qt_cmake_dir "${vcpkg_dir}/share/cmake/Qt5")
    set(qt_qmake_dir "${vcpkg_dir}/tools/qt5/bin")
elseif (USE_QT)
    #For convenience, added some default qt paths if none is specified
    if (NOT DEFINED QT_DIR)
        if (CMAKE_HOST_WIN32 )
            if (build_64_bit)
                set (QT_DIR "C:/Qt/${MEGA_QT_VERSION}/msvc2017_64" CACHE STRING "Specify your QT install folder if it is nonstandard")
            else()
                set (QT_DIR "C:/Qt/${MEGA_QT_VERSION}/msvc2017" CACHE STRING "Specify your QT install folder if it is nonstandard")
            ENDIF()
        ELSE()
            set (QT_DIR "/Users/Shared/Qt/${MEGA_QT_VERSION}/clang_64" CACHE STRING "Specify your QT install folder if it is nonstandard")
        ENDIF()
    ENDIF()

    set(qt_cmake_dir "${QT_DIR}/lib/cmake/Qt5")
    set(qt_qmake_dir "${QT_DIR}/bin")
endif()

if (USE_QT OR USE_QT_FROM_VCPKG)
    message(STATUS "USE_QT: ${USE_QT} USE_QT_FROM_VCPKG: ${USE_QT_FROM_VCPKG}")
    message(STATUS "QT_DIR: ${QT_DIR}")

    # find qt package
    if (NOT DEFINED CMAKE_PREFIX_PATH)
        set(CMAKE_PREFIX_PATH "${qt_cmake_dir}")
    endif()

    message(STATUS "CMAKE_PREFIX_PATH (should contain the QT install path): ${CMAKE_PREFIX_PATH}")

    foreach (PKG IN LISTS MEGA_QT_REQUIRED_COMPONENTS)
        message(STATUS "Finding Qt package ${PKG}")
        find_package(Qt5 COMPONENTS ${PKG} REQUIRED)
    endforeach(PKG)

    # get qt version
    if ("${QT_QMAKE_EXECUTABLE}" STREQUAL "")
        if(WIN32)
            set(QT_QMAKE_EXECUTABLE "${qt_qmake_dir}/qmake.exe")
        else()
            set(QT_QMAKE_EXECUTABLE "${qt_qmake_dir}/qmake")
        endif()
    endif()

    execute_process(COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_VERSION OUTPUT_VARIABLE QT_VERSION OUTPUT_STRIP_TRAILING_WHITESPACE)
    message(STATUS "Using QT ${QT_VERSION} from ${QT_QMAKE_EXECUTABLE}")
endif()

if (NOT CMAKE_BUILD_TYPE)
    message("Generated with config types: ${CMAKE_CONFIGURATION_TYPES}")
else(NOT CMAKE_BUILD_TYPE)
    message("CMAKE_BUILD_TYPE is ${CMAKE_BUILD_TYPE}")
endif(NOT CMAKE_BUILD_TYPE)

#windows projects usually need _DEBUG and/or DEBUG set rather than NDEBUG not set
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -D_DEBUG -DDEBUG")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -D_DEBUG -DDEBUG")

if (WIN32)
    # node deletion in debug under VC++ is pretty slow without this.  However libraries we depend on need to be built with the same setting or linking fails
    # (hence the build3rdParty script using the xNN-windows-static-uncheckediterators triplets)
    if (UNCHECKED_ITERATORS)

=== doc/example/Makefile ===
TARGET = lsmega
CC = g++
SOURCES= lsmega.cpp
OBJECTS=$(SOURCES:.cpp=.o)
# set -DDEBUG=1 to enable debug output
#DEBUG_FLAG=-DDEBUG=1
DEBUG_FLAG=
CXXFLAGS=$(DEBUG_FLAG) -Wall `pkg-config --cflags libmega libcrypto++` `curl-config --cflags`
LDFLAGS=`pkg-config --libs libmega libcrypto++` `curl-config --libs` -lrt

all: $(TARGET)

# objects
.cpp.o:
	$(CXX) -c $(CXXFLAGS) $(INC) $< -o $@

# apps
$(TARGET): $(OBJECTS)
	$(CXX) $(CFLAGS) $^ -o $@ $(LIB) $(LDFLAGS) 

clean:
	-rm $(TARGET)
	-rm -f *.o
	-rm -f core

=== contrib/cmake/build3rdParty/CMakeLists.txt ===


cmake_minimum_required(VERSION 3.13)
project(Build3rdParty)

if (WIN32)
    # accurate __cplusplus macro for vc++, selecting c++17 here for windows builds though the MEGA SDK library must build for older c++ standards also
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zc:__cplusplus /std:c++17")
endif()

if (APPLE)
    set(CMAKE_CXX_STANDARD 11)
    SET(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()

add_executable(build3rdParty build3rdParty.cpp)
if (NOT WIN32 AND NOT APPLE)
    target_link_libraries(build3rdParty stdc++fs)
endif()

=== bindings/doc/java/sphinx/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest coverage gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  applehelp  to make an Apple Help Book"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  coverage   to run coverage check of the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/JavaUserguide.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/JavaUserguide.qhc"

applehelp:
	$(SPHINXBUILD) -b applehelp $(ALLSPHINXOPTS) $(BUILDDIR)/applehelp
	@echo
	@echo "Build finished. The help book is in $(BUILDDIR)/applehelp."
	@echo "N.B. You won't be able to view it unless you put it in" \
	      "~/Library/Documentation/Help or install it in your application" \
	      "bundle."

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/JavaUserguide"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/JavaUserguide"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

coverage:
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) $(BUILDDIR)/coverage
	@echo "Testing of coverage in the sources finished, look at the " \
	      "results in $(BUILDDIR)/coverage/python.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== contrib/cmake/vcpkg_overlay_ports/pdfium/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.7.2)
project(pdfium_by_cmake)

set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -D_DEBUG -DDEBUG")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -D_DEBUG -DDEBUG")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if(WIN32)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /EHsc /MP")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc /MP ")
	add_definitions(-DHAVE_BOOLEAN)
endif()

if(APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -isysroot /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX.sdk" )
endif()

add_definitions(-DCMS_NO_REGISTER_KEYWORD -DUNICODE -DNOMINMAX -DUSE_LIBJPEG_TURBO -DPNG_PREFIX  -DUSE_SYSTEM_ICUUC -DUSE_SYSTEM_LIBJPEG -DUSE_SYSTEM_LCMS2 -DUSE_SYSTEM_ZLIB -DUSE_SYSTEM_LIBOPENJPEG2 -DOPJ_STATIC -DDEFINE_PS_TABLES)
# no skia, V8, or xfa (xfa seems to require V8 anyway)

find_package(OpenJPEG      REQUIRED)
find_package(lcms          REQUIRED)
find_package(JPEG          REQUIRED)
find_package(BZip2         REQUIRED)
find_package(libpng        REQUIRED)

include_directories(
    ${JPEG_INCLUDE_DIRS}
    ${BZIP2_INCLUDE_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/third_party/abseil-cpp
    "."
)

if(WIN32)
     set(WIN 1)
else()
     set(WIN 0)
endif()

if (APPLE)
    set(MAC 1)
else()
    set(MAC 0)
endif()

if (NOT WIN32 AND NOT APPLE)
    set(LINUX 1)
else()
    set(LINUX 0)
endif()

set(ANDROID 0)


add_library(pdfium STATIC)

target_sources(pdfium PRIVATE
third_party/abseil-cpp/absl/strings/internal/str_format/output.cc
third_party/abseil-cpp/absl/strings/internal/str_format/parser.cc
third_party/abseil-cpp/absl/strings/internal/ostringstream.cc
third_party/abseil-cpp/absl/strings/internal/escaping.cc
third_party/abseil-cpp/absl/strings/internal/utf8.cc
third_party/abseil-cpp/absl/strings/internal/str_format/arg.cc
third_party/abseil-cpp/absl/strings/internal/str_format/bind.cc
third_party/abseil-cpp/absl/strings/internal/str_format/extension.cc
third_party/abseil-cpp/absl/strings/internal/str_format/float_conversion.cc
third_party/abseil-cpp/absl/strings/ascii.cc
third_party/abseil-cpp/absl/strings/internal/memutil.cc
third_party/abseil-cpp/absl/strings/match.cc
third_party/abseil-cpp/absl/strings/numbers.cc
third_party/abseil-cpp/absl/strings/str_cat.cc
third_party/abseil-cpp/absl/strings/str_replace.cc
third_party/abseil-cpp/absl/strings/str_split.cc
third_party/abseil-cpp/absl/strings/string_view.cc
third_party/abseil-cpp/absl/strings/substitute.cc
third_party/abseil-cpp/absl/strings/charconv.cc
third_party/abseil-cpp/absl/strings/escaping.cc
third_party/abseil-cpp/absl/strings/internal/charconv_bigint.cc
third_party/abseil-cpp/absl/strings/internal/charconv_parse.cc
third_party/abseil-cpp/absl/synchronization/internal/graphcycles.cc
third_party/abseil-cpp/absl/synchronization/barrier.cc
third_party/abseil-cpp/absl/synchronization/blocking_counter.cc
third_party/abseil-cpp/absl/synchronization/internal/create_thread_identity.cc
third_party/abseil-cpp/absl/synchronization/internal/per_thread_sem.cc
third_party/abseil-cpp/absl/synchronization/internal/waiter.cc
third_party/abseil-cpp/absl/synchronization/mutex.cc
third_party/abseil-cpp/absl/synchronization/notification.cc
third_party/abseil-cpp/absl/time/civil_time.cc
third_party/abseil-cpp/absl/time/clock.cc
third_party/abseil-cpp/absl/time/duration.cc
third_party/abseil-cpp/absl/time/format.cc
third_party/abseil-cpp/absl/time/time.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/civil_time_detail.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/time_zone_fixed.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/time_zone_format.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/time_zone_if.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/time_zone_impl.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/time_zone_info.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/time_zone_libc.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/time_zone_lookup.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/time_zone_posix.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/zone_info_source.cc
third_party/abseil-cpp/absl/types/bad_optional_access.cc
third_party/abseil-cpp/absl/types/bad_variant_access.cc
constants/appearance.cpp
constants/annotation_common.cpp
constants/font_encodings.cpp
constants/form_fields.cpp
constants/page_object.cpp
constants/stream_dict_common.cpp
constants/transparency.cpp
core/fdrm/fx_crypt.cpp
core/fdrm/fx_crypt_aes.cpp
core/fdrm/fx_crypt_sha.cpp
core/fpdfapi/cmaps/Japan1/90ms-RKSJ-H_2.cpp
core/fpdfapi/cmaps/Japan1/90ms-RKSJ-V_2.cpp
core/fpdfapi/cmaps/Japan1/90msp-RKSJ-H_2.cpp
core/fpdfapi/cmaps/Japan1/90pv-RKSJ-H_1.cpp
core/fpdfapi/cmaps/Japan1/Add-RKSJ-H_1.cpp
core/fpdfapi/cmaps/Japan1/Add-RKSJ-V_1.cpp
core/fpdfapi/cmaps/Japan1/Adobe-Japan1-UCS2_4.cpp
core/fpdfapi/cmaps/Japan1/EUC-H_1.cpp
core/fpdfapi/cmaps/Japan1/EUC-V_1.cpp
core/fpdfapi/cmaps/GB1/UniGB-UCS2-H_4.cpp
core/fpdfapi/cmaps/GB1/UniGB-UCS2-V_4.cpp
core/fpdfapi/cmaps/GB1/cmaps_gb1.cpp
core/fpdfapi/cmaps/Japan1/83pv-RKSJ-H_1.cpp
core/fpdfapi/cmaps/CNS1/Adobe-CNS1-UCS2_5.cpp
core/fpdfapi/cmaps/CNS1/B5pc-H_0.cpp
core/fpdfapi/cmaps/CNS1/B5pc-V_0.cpp
core/fpdfapi/cmaps/CNS1/CNS-EUC-H_0.cpp
core/fpdfapi/cmaps/CNS1/CNS-EUC-V_0.cpp
core/fpdfapi/cmaps/CNS1/ETen-B5-H_0.cpp
core/fpdfapi/cmaps/CNS1/ETen-B5-V_0.cpp
core/fpdfapi/cmaps/CNS1/ETenms-B5-H_0.cpp
core/fpdfapi/cmaps/CNS1/ETenms-B5-V_0.cpp
core/fpdfapi/cmaps/CNS1/HKscs-B5-H_5.cpp
core/fpdfapi/cmaps/CNS1/HKscs-B5-V_5.cpp
core/fpdfapi/cmaps/CNS1/UniCNS-UCS2-H_3.cpp
core/fpdfapi/cmaps/CNS1/UniCNS-UCS2-V_3.cpp
core/fpdfapi/cmaps/CNS1/UniCNS-UTF16-H_0.cpp
core/fpdfapi/cmaps/CNS1/cmaps_cns1.cpp
core/fpdfapi/cmaps/GB1/Adobe-GB1-UCS2_5.cpp
core/fpdfapi/cmaps/GB1/GB-EUC-H_0.cpp
core/fpdfapi/cmaps/Japan1/90msp-RKSJ-V_2.cpp
core/fpdfapi/cmaps/GB1/GB-EUC-V_0.cpp
core/fpdfapi/cmaps/GB1/GBK-EUC-H_2.cpp
core/fpdfapi/cmaps/GB1/GBK-EUC-V_2.cpp
core/fpdfapi/cmaps/GB1/GBK2K-H_5.cpp
core/fpdfapi/cmaps/GB1/GBK2K-V_5.cpp
core/fpdfapi/cmaps/GB1/GBKp-EUC-H_2.cpp
core/fpdfapi/cmaps/GB1/GBKp-EUC-V_2.cpp
core/fpdfapi/cmaps/GB1/GBpc-EUC-H_0.cpp
core/fpdfapi/cmaps/GB1/GBpc-EUC-V_0.cpp
core/fpdfapi/cmaps/Japan1/Ext-RKSJ-H_2.cpp
core/fpdfapi/cmaps/Japan1/Ext-RKSJ-V_2.cpp
core/fpdfapi/cmaps/Japan1/H_1.cpp
core/fpdfapi/cmaps/Japan1/UniJIS-UCS2-HW-H_4.cpp
core/fpdfapi/cmaps/Japan1/UniJIS-UCS2-HW-V_4.cpp
core/fpdfapi/cmaps/Japan1/UniJIS-UCS2-H_4.cpp
core/fpdfapi/cmaps/Japan1/UniJIS-UCS2-V_4.cpp
core/fpdfapi/cmaps/Japan1/V_1.cpp
core/fpdfapi/cmaps/Japan1/cmaps_japan1.cpp
core/fpdfapi/cmaps/Korea1/Adobe-Korea1-UCS2_2.cpp
core/fpdfapi/cmaps/Korea1/KSC-EUC-H_0.cpp
core/fpdfapi/cmaps/Korea1/KSC-EUC-V_0.cpp
core/fpdfapi/cmaps/Korea1/KSCms-UHC-HW-H_1.cpp
core/fpdfapi/cmaps/Korea1/KSCms-UHC-HW-V_1.cpp
core/fpdfapi/cmaps/Korea1/KSCms-UHC-H_1.cpp
core/fpdfapi/cmaps/Korea1/KSCms-UHC-V_1.cpp
core/fpdfapi/cmaps/Korea1/KSCpc-EUC-H_0.cpp
core/fpdfapi/cmaps/Korea1/UniKS-UCS2-H_1.cpp
core/fpdfapi/cmaps/Korea1/UniKS-UCS2-V_1.cpp
core/fpdfapi/cmaps/Korea1/UniKS-UTF16-H_0.cpp
core/fpdfapi/cmaps/Korea1/cmaps_korea1.cpp
core/fpdfapi/cmaps/fpdf_cmaps.cpp
core/fpdfapi/edit/cpdf_contentstream_write_utils.cpp
core/fpdfapi/edit/cpdf_creator.cpp
core/fpdfapi/edit/cpdf_pagecontentgenerator.cpp
core/fpdfapi/edit/cpdf_pagecontentmanager.cpp
core/fpdfapi/edit/cpdf_stringarchivestream.cpp
core/fpdfapi/font/cfx_cttgsubtable.cpp
core/fpdfapi/font/cfx_stockfontarray.cpp
core/fpdfapi/font/cpdf_cid2unicodemap.cpp
core/fpdfapi/font/cpdf_cidfont.cpp
core/fpdfapi/font/cpdf_cmap.cpp
core/fpdfapi/font/cpdf_cmapparser.cpp
core/fpdfapi/font/cpdf_font.cpp
core/fpdfapi/font/cpdf_fontencoding.cpp
core/fpdfapi/font/cpdf_fontglobals.cpp
core/fpdfapi/font/cpdf_simplefont.cpp
core/fpdfapi/font/cpdf_tounicodemap.cpp
core/fpdfapi/font/cpdf_truetypefont.cpp
core/fpdfapi/font/cpdf_type1font.cpp
core/fpdfapi/font/cpdf_type3char.cpp
core/fpdfapi/font/cpdf_type3font.cpp
core/fpdfapi/page/cpdf_page.cpp
core/fpdfapi/page/cpdf_pagemodule.cpp
core/fpdfapi/page/cpdf_pageobject.cpp
core/fpdfapi/page/cpdf_pageobjectholder.cpp
core/fpdfapi/page/cpdf_path.cpp
core/fpdfapi/page/cpdf_pathobject.cpp
core/fpdfapi/page/cpdf_pattern.cpp
core/fpdfapi/page/cpdf_patterncs.cpp
core/fpdfapi/page/cpdf_psengine.cpp
core/fpdfapi/page/cpdf_psfunc.cpp
core/fpdfapi/page/cpdf_sampledfunc.cpp
core/fpdfapi/page/cpdf_shadingobject.cpp
core/fpdfapi/page/cpdf_shadingpattern.cpp
core/fpdfapi/page/cpdf_stitchfunc.cpp
core/fpdfapi/page/cpdf_graphicstates.cpp
core/fpdfapi/page/cpdf_iccprofile.cpp
core/fpdfapi/page/cpdf_image.cpp
core/fpdfapi/page/cpdf_imageobject.cpp
core/fpdfapi/page/cpdf_indexedcs.cpp
core/fpdfapi/page/cpdf_meshstream.cpp
core/fpdfapi/page/cpdf_occontext.cpp
core/fpdfapi/page/cpdf_allstates.cpp
core/fpdfapi/page/cpdf_annotcontext.cpp
core/fpdfapi/page/cpdf_basedcs.cpp
core/fpdfapi/page/cpdf_clippath.cpp
core/fpdfapi/page/cpdf_color.cpp
core/fpdfapi/page/cpdf_colorspace.cpp
core/fpdfapi/page/cpdf_colorstate.cpp
core/fpdfapi/page/cpdf_contentmarkitem.cpp
core/fpdfapi/page/cpdf_contentmarks.cpp
core/fpdfapi/page/cpdf_contentparser.cpp
core/fpdfapi/page/cpdf_devicecs.cpp
core/fpdfapi/page/cpdf_dib.cpp
core/fpdfapi/page/cpdf_docpagedata.cpp
core/fpdfapi/page/cpdf_expintfunc.cpp
core/fpdfapi/page/cpdf_form.cpp
core/fpdfapi/page/cpdf_formobject.cpp
core/fpdfapi/page/cpdf_function.cpp
core/fpdfapi/page/cpdf_generalstate.cpp
core/fpdfapi/page/cpdf_streamcontentparser.cpp
core/fpdfapi/page/cpdf_streamparser.cpp
core/fpdfapi/page/cpdf_textobject.cpp
core/fpdfapi/page/cpdf_textstate.cpp
core/fpdfapi/page/cpdf_tilingpattern.cpp
core/fpdfapi/page/cpdf_transferfunc.cpp
core/fpdfapi/page/cpdf_transferfuncdib.cpp
core/fpdfapi/page/cpdf_transparency.cpp
core/fpdfapi/parser/cpdf_flateencoder.cpp
core/fpdfapi/parser/cpdf_hint_tables.cpp
core/fpdfapi/parser/cpdf_indirect_object_holder.cpp
core/fpdfapi/parser/cpdf_linearized_header.cpp
core/fpdfapi/parser/cpdf_name.cpp
core/fpdfapi/parser/cpdf_null.cpp
core/fpdfapi/parser/cpdf_number.cpp
core/fpdfapi/parser/cpdf_object.cpp
core/fpdfapi/parser/cpdf_object_avail.cpp
core/fpdfapi/parser/cpdf_object_stream.cpp
core/fpdfapi/parser/cpdf_object_walker.cpp
core/fpdfapi/parser/cpdf_page_object_avail.cpp
core/fpdfapi/parser/cpdf_parser.cpp
core/fpdfapi/parser/cpdf_read_validator.cpp
core/fpdfapi/parser/cpdf_reference.cpp
core/fpdfapi/parser/cpdf_security_handler.cpp
core/fpdfapi/parser/cpdf_simple_parser.cpp
core/fpdfapi/parser/cpdf_stream.cpp
core/fpdfapi/parser/cpdf_stream_acc.cpp
core/fpdfapi/parser/cpdf_string.cpp
core/fpdfapi/parser/cpdf_syntax_parser.cpp
core/fpdfapi/parser/fpdf_parser_decode.cpp
core/fpdfapi/parser/fpdf_parser_utility.cpp
core/fpdfapi/parser/cfdf_document.cpp
core/fpdfapi/parser/cpdf_array.cpp
core/fpdfapi/parser/cpdf_boolean.cpp
core/fpdfapi/parser/cpdf_cross_ref_avail.cpp
core/fpdfapi/parser/cpdf_cross_ref_table.cpp
core/fpdfapi/parser/cpdf_crypto_handler.cpp
core/fpdfapi/parser/cpdf_data_avail.cpp
core/fpdfapi/parser/cpdf_dictionary.cpp
core/fpdfapi/parser/cpdf_document.cpp
core/fpdfapi/parser/cpdf_encryptor.cpp
core/fpdfapi/render/charposlist.cpp
core/fpdfapi/render/cpdf_devicebuffer.cpp
core/fpdfapi/render/cpdf_docrenderdata.cpp
core/fpdfapi/render/cpdf_imageloader.cpp
core/fpdfapi/render/cpdf_imagerenderer.cpp
core/fpdfapi/render/cpdf_pagerendercache.cpp
core/fpdfapi/render/cpdf_pagerendercontext.cpp
core/fpdfapi/render/cpdf_progressiverenderer.cpp
core/fpdfapi/render/cpdf_rendercontext.cpp
core/fpdfapi/render/cpdf_renderoptions.cpp
core/fpdfapi/render/cpdf_rendershading.cpp
core/fpdfapi/render/cpdf_renderstatus.cpp
core/fpdfapi/render/cpdf_rendertiling.cpp
core/fpdfapi/render/cpdf_scaledrenderbuffer.cpp
$<${WIN}:core/fpdfapi/render/cpdf_windowsrenderdevice.cpp>
core/fpdfapi/render/cpdf_textrenderer.cpp
core/fpdfapi/render/cpdf_type3cache.cpp
core/fpdfapi/render/cpdf_type3glyphmap.cpp
core/fpdfdoc/cpvt_fontmap.cpp
core/fpdfdoc/cpvt_section.cpp
core/fpdfdoc/cpvt_variabletext.cpp
core/fpdfdoc/cpvt_wordinfo.cpp

=== contrib/cmake/vcpkg_extra_ports/pdfium/3710/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.7.2)
project(pdfium_by_cmake)

set(_VCPKG_ROOT_DIR "${_VCPKG_ROOT_DIR}${VCPKG_ROOT_DIR}")

set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -D_DEBUG -DDEBUG")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -D_DEBUG -DDEBUG")

if(WIN32)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /EHsc /MP")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc /MP ")  
	add_definitions(-DHAVE_BOOLEAN )
endif()

if(APPLE)
    set(CMAKE_CXX_STANDARD 11)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -isysroot /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX.sdk" )
endif()

add_definitions( -DUNICODE -DNOMINMAX -DUSE_LIBJPEG_TURBO -DPNG_PREFIX  -DUSE_SYSTEM_ICUUC -DUSE_SYSTEM_LIBJPEG -DUSE_SYSTEM_LCMS2 -DUSE_SYSTEM_ZLIB -DUSE_SYSTEM_LIBOPENJPEG2 -DOPJ_STATIC -DDEFINE_PS_TABLES)
# no skia, V8, or xfa (xfa seems to require V8 anyway)

set(PdfiumDir "${_VCPKG_ROOT_DIR}/pdfium/pdfium")

#todo: figure out how to use the vckpg triplet here
include_directories( 
    ${PdfiumDir}
    ${PdfiumDir}/third_party/freetype/src/include
    ${PdfiumDir}/../../installed/${VCPKG_TARGET_TRIPLET}/include
)

message("include vcpkg: ${_VCPKG_ROOT_DIR}/installed/${VCPKG_TARGET_TRIPLET}/include")

if(WIN32)
     set(WIN 1)
else()
     set(WIN 0)
endif()

if (APPLE)
    set(MAC 1)
else()
    set(MAC 0)
endif()

if (NOT WIN32 AND NOT APPLE)
    set(LINUX 1)
else()
    set(LINUX 0)
endif()

set(ANDROID 0)


add_library(pdfium STATIC

${PdfiumDir}/core/fdrm/fx_crypt.cpp
${PdfiumDir}/core/fdrm/fx_crypt_aes.cpp
${PdfiumDir}/core/fdrm/fx_crypt_sha.cpp
#${PdfiumDir}/core/fdrm/fx_crypt_unittest.cpp
${PdfiumDir}/core/fpdfapi/cmaps/CNS1/Adobe-CNS1-UCS2_5.cpp
${PdfiumDir}/core/fpdfapi/cmaps/CNS1/B5pc-H_0.cpp
${PdfiumDir}/core/fpdfapi/cmaps/CNS1/B5pc-V_0.cpp
${PdfiumDir}/core/fpdfapi/cmaps/CNS1/cmaps_cns1.cpp
${PdfiumDir}/core/fpdfapi/cmaps/CNS1/CNS-EUC-H_0.cpp
${PdfiumDir}/core/fpdfapi/cmaps/CNS1/CNS-EUC-V_0.cpp
${PdfiumDir}/core/fpdfapi/cmaps/CNS1/ETen-B5-H_0.cpp
${PdfiumDir}/core/fpdfapi/cmaps/CNS1/ETen-B5-V_0.cpp
${PdfiumDir}/core/fpdfapi/cmaps/CNS1/ETenms-B5-H_0.cpp
${PdfiumDir}/core/fpdfapi/cmaps/CNS1/ETenms-B5-V_0.cpp
${PdfiumDir}/core/fpdfapi/cmaps/CNS1/HKscs-B5-H_5.cpp
${PdfiumDir}/core/fpdfapi/cmaps/CNS1/HKscs-B5-V_5.cpp
${PdfiumDir}/core/fpdfapi/cmaps/CNS1/UniCNS-UCS2-H_3.cpp
${PdfiumDir}/core/fpdfapi/cmaps/CNS1/UniCNS-UCS2-V_3.cpp
${PdfiumDir}/core/fpdfapi/cmaps/CNS1/UniCNS-UTF16-H_0.cpp
${PdfiumDir}/core/fpdfapi/cmaps/fpdf_cmaps.cpp
${PdfiumDir}/core/fpdfapi/cmaps/GB1/Adobe-GB1-UCS2_5.cpp
${PdfiumDir}/core/fpdfapi/cmaps/GB1/cmaps_gb1.cpp
${PdfiumDir}/core/fpdfapi/cmaps/GB1/GB-EUC-H_0.cpp
${PdfiumDir}/core/fpdfapi/cmaps/GB1/GB-EUC-V_0.cpp
${PdfiumDir}/core/fpdfapi/cmaps/GB1/GBK-EUC-H_2.cpp
${PdfiumDir}/core/fpdfapi/cmaps/GB1/GBK-EUC-V_2.cpp
${PdfiumDir}/core/fpdfapi/cmaps/GB1/GBK2K-H_5.cpp
${PdfiumDir}/core/fpdfapi/cmaps/GB1/GBK2K-V_5.cpp
${PdfiumDir}/core/fpdfapi/cmaps/GB1/GBKp-EUC-H_2.cpp
${PdfiumDir}/core/fpdfapi/cmaps/GB1/GBKp-EUC-V_2.cpp
${PdfiumDir}/core/fpdfapi/cmaps/GB1/GBpc-EUC-H_0.cpp
${PdfiumDir}/core/fpdfapi/cmaps/GB1/GBpc-EUC-V_0.cpp
${PdfiumDir}/core/fpdfapi/cmaps/GB1/UniGB-UCS2-H_4.cpp
${PdfiumDir}/core/fpdfapi/cmaps/GB1/UniGB-UCS2-V_4.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/83pv-RKSJ-H_1.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/90ms-RKSJ-H_2.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/90ms-RKSJ-V_2.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/90msp-RKSJ-H_2.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/90msp-RKSJ-V_2.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/90pv-RKSJ-H_1.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/Add-RKSJ-H_1.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/Add-RKSJ-V_1.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/Adobe-Japan1-UCS2_4.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/cmaps_japan1.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/EUC-H_1.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/EUC-V_1.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/Ext-RKSJ-H_2.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/Ext-RKSJ-V_2.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/H_1.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/UniJIS-UCS2-HW-H_4.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/UniJIS-UCS2-HW-V_4.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/UniJIS-UCS2-H_4.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/UniJIS-UCS2-V_4.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Japan1/V_1.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Korea1/Adobe-Korea1-UCS2_2.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Korea1/cmaps_korea1.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Korea1/KSC-EUC-H_0.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Korea1/KSC-EUC-V_0.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Korea1/KSCms-UHC-HW-H_1.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Korea1/KSCms-UHC-HW-V_1.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Korea1/KSCms-UHC-H_1.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Korea1/KSCms-UHC-V_1.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Korea1/KSCpc-EUC-H_0.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Korea1/UniKS-UCS2-H_1.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Korea1/UniKS-UCS2-V_1.cpp
${PdfiumDir}/core/fpdfapi/cmaps/Korea1/UniKS-UTF16-H_0.cpp
${PdfiumDir}/core/fpdfapi/cpdf_modulemgr.cpp
${PdfiumDir}/core/fpdfapi/cpdf_pagerendercontext.cpp
${PdfiumDir}/core/fpdfapi/edit/cpdf_creator.cpp
##${PdfiumDir}/core/fpdfapi/edit/cpdf_creator_embeddertest.cpp
${PdfiumDir}/core/fpdfapi/edit/cpdf_pagecontentgenerator.cpp
#${PdfiumDir}/core/fpdfapi/edit/cpdf_pagecontentgenerator_unittest.cpp
${PdfiumDir}/core/fpdfapi/edit/cpdf_pagecontentmanager.cpp
${PdfiumDir}/core/fpdfapi/edit/cpdf_stringarchivestream.cpp
${PdfiumDir}/core/fpdfapi/font/cfx_cttgsubtable.cpp
${PdfiumDir}/core/fpdfapi/font/cfx_stockfontarray.cpp
${PdfiumDir}/core/fpdfapi/font/cpdf_cid2unicodemap.cpp
${PdfiumDir}/core/fpdfapi/font/cpdf_cidfont.cpp
#${PdfiumDir}/core/fpdfapi/font/cpdf_cidfont_unittest.cpp
${PdfiumDir}/core/fpdfapi/font/cpdf_cmap.cpp
${PdfiumDir}/core/fpdfapi/font/cpdf_cmapmanager.cpp
${PdfiumDir}/core/fpdfapi/font/cpdf_cmapparser.cpp
#${PdfiumDir}/core/fpdfapi/font/cpdf_cmapparser_unittest.cpp
${PdfiumDir}/core/fpdfapi/font/cpdf_font.cpp
${PdfiumDir}/core/fpdfapi/font/cpdf_fontencoding.cpp
#${PdfiumDir}/core/fpdfapi/font/cpdf_fontencoding_unittest.cpp
${PdfiumDir}/core/fpdfapi/font/cpdf_fontglobals.cpp
${PdfiumDir}/core/fpdfapi/font/cpdf_simplefont.cpp
${PdfiumDir}/core/fpdfapi/font/cpdf_tounicodemap.cpp
#${PdfiumDir}/core/fpdfapi/font/cpdf_tounicodemap_unittest.cpp
${PdfiumDir}/core/fpdfapi/font/cpdf_truetypefont.cpp
${PdfiumDir}/core/fpdfapi/font/cpdf_type1font.cpp
${PdfiumDir}/core/fpdfapi/font/cpdf_type3char.cpp
${PdfiumDir}/core/fpdfapi/font/cpdf_type3font.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_allstates.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_clippath.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_color.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_colorspace.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_colorstate.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_contentmarkitem.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_contentmarks.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_contentparser.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_devicecs.cpp
#${PdfiumDir}/core/fpdfapi/page/cpdf_devicecs_unittest.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_docpagedata.cpp
#${PdfiumDir}/core/fpdfapi/page/cpdf_docpagedata_embeddertest.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_expintfunc.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_form.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_formobject.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_function.cpp
#${PdfiumDir}/core/fpdfapi/page/cpdf_function_embeddertest.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_generalstate.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_graphicstates.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_iccprofile.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_image.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_imageobject.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_meshstream.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_page.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_pagemodule.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_pageobject.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_pageobjectholder.cpp
#${PdfiumDir}/core/fpdfapi/page/cpdf_pageobjectholder_unittest.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_pageobjectlist.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_path.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_pathobject.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_pattern.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_patterncs.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_psengine.cpp
#${PdfiumDir}/core/fpdfapi/page/cpdf_psengine_unittest.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_psfunc.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_sampledfunc.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_shadingobject.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_shadingpattern.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_stitchfunc.cpp
#${PdfiumDir}/core/fpdfapi/page/cpdf_stitchfunc_embeddertest.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_streamcontentparser.cpp
#${PdfiumDir}/core/fpdfapi/page/cpdf_streamcontentparser_unittest.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_streamparser.cpp
#${PdfiumDir}/core/fpdfapi/page/cpdf_streamparser_unittest.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_textobject.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_textstate.cpp
${PdfiumDir}/core/fpdfapi/page/cpdf_tilingpattern.cpp
${PdfiumDir}/core/fpdfapi/parser/cfdf_document.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_array.cpp
#${PdfiumDir}/core/fpdfapi/parser/cpdf_array_unittest.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_boolean.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_cross_ref_avail.cpp
#${PdfiumDir}/core/fpdfapi/parser/cpdf_cross_ref_avail_unittest.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_cross_ref_table.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_crypto_handler.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_data_avail.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_dictionary.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_document.cpp
#${PdfiumDir}/core/fpdfapi/parser/cpdf_document_unittest.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_encryptor.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_flateencoder.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_hint_tables.cpp
#${PdfiumDir}/core/fpdfapi/parser/cpdf_hint_tables_unittest.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_indirect_object_holder.cpp
#${PdfiumDir}/core/fpdfapi/parser/cpdf_indirect_object_holder_unittest.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_linearized_header.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_name.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_null.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_number.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_object.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_object_avail.cpp
#${PdfiumDir}/core/fpdfapi/parser/cpdf_object_avail_unittest.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_object_stream.cpp
#${PdfiumDir}/core/fpdfapi/parser/cpdf_object_unittest.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_object_walker.cpp
#${PdfiumDir}/core/fpdfapi/parser/cpdf_object_walker_unittest.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_page_object_avail.cpp
#${PdfiumDir}/core/fpdfapi/parser/cpdf_page_object_avail_unittest.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_parser.cpp
#${PdfiumDir}/core/fpdfapi/parser/cpdf_parser_embeddertest.cpp
#${PdfiumDir}/core/fpdfapi/parser/cpdf_parser_unittest.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_read_validator.cpp
#${PdfiumDir}/core/fpdfapi/parser/cpdf_read_validator_unittest.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_reference.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_security_handler.cpp
#${PdfiumDir}/core/fpdfapi/parser/cpdf_security_handler_embeddertest.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_simple_parser.cpp
#${PdfiumDir}/core/fpdfapi/parser/cpdf_simple_parser_unittest.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_stream.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_stream_acc.cpp
#${PdfiumDir}/core/fpdfapi/parser/cpdf_stream_acc_unittest.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_string.cpp
${PdfiumDir}/core/fpdfapi/parser/cpdf_syntax_parser.cpp
#${PdfiumDir}/core/fpdfapi/parser/cpdf_syntax_parser_unittest.cpp
${PdfiumDir}/core/fpdfapi/parser/fpdf_parser_decode.cpp
#${PdfiumDir}/core/fpdfapi/parser/fpdf_parser_decode_embeddertest.cpp

=== contrib/cmake/vcpkg_extra_ports/pdfium/5247/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.7.2)
project(pdfium_by_cmake)

set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -D_DEBUG -DDEBUG")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -D_DEBUG -DDEBUG")

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if(WIN32)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /EHsc /MP")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc /MP ")  
	add_definitions(-DHAVE_BOOLEAN)
endif()

if(APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -isysroot /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX.sdk" )
endif()

add_definitions(-DCMS_NO_REGISTER_KEYWORD -DUNICODE -DNOMINMAX -DUSE_LIBJPEG_TURBO -DPNG_PREFIX  -DUSE_SYSTEM_ICUUC -DUSE_SYSTEM_LIBJPEG -DUSE_SYSTEM_LCMS2 -DUSE_SYSTEM_ZLIB -DUSE_SYSTEM_LIBOPENJPEG2 -DOPJ_STATIC -DDEFINE_PS_TABLES)
# no skia, V8, or xfa (xfa seems to require V8 anyway)

find_package(OpenJPEG      REQUIRED)
find_package(lcms          REQUIRED)
find_package(JPEG          REQUIRED)
find_package(BZip2         REQUIRED)
find_package(libpng        REQUIRED)

include_directories(
    ${JPEG_INCLUDE_DIRS}
    ${BZIP2_INCLUDE_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}/third_party/abseil-cpp
    "."
)

if(WIN32)
     set(WIN 1)
else()
     set(WIN 0)
endif()

if (APPLE)
    set(MAC 1)
else()
    set(MAC 0)
endif()

if (NOT WIN32 AND NOT APPLE)
    set(LINUX 1)
else()
    set(LINUX 0)
endif()

set(ANDROID 0)


add_library(pdfium STATIC)

target_sources(pdfium PRIVATE
third_party/abseil-cpp/absl/strings/internal/str_format/output.cc
third_party/abseil-cpp/absl/strings/internal/str_format/parser.cc
third_party/abseil-cpp/absl/strings/internal/ostringstream.cc
third_party/abseil-cpp/absl/strings/internal/escaping.cc
third_party/abseil-cpp/absl/strings/internal/utf8.cc
third_party/abseil-cpp/absl/strings/internal/str_format/arg.cc
third_party/abseil-cpp/absl/strings/internal/str_format/bind.cc
third_party/abseil-cpp/absl/strings/internal/str_format/extension.cc
third_party/abseil-cpp/absl/strings/internal/str_format/float_conversion.cc
third_party/abseil-cpp/absl/strings/ascii.cc
third_party/abseil-cpp/absl/strings/internal/memutil.cc
third_party/abseil-cpp/absl/strings/match.cc
third_party/abseil-cpp/absl/strings/numbers.cc
third_party/abseil-cpp/absl/strings/str_cat.cc
third_party/abseil-cpp/absl/strings/str_replace.cc
third_party/abseil-cpp/absl/strings/str_split.cc
third_party/abseil-cpp/absl/strings/string_view.cc
third_party/abseil-cpp/absl/strings/substitute.cc
third_party/abseil-cpp/absl/strings/charconv.cc
third_party/abseil-cpp/absl/strings/escaping.cc
third_party/abseil-cpp/absl/strings/internal/charconv_bigint.cc
third_party/abseil-cpp/absl/strings/internal/charconv_parse.cc
third_party/abseil-cpp/absl/synchronization/internal/graphcycles.cc
third_party/abseil-cpp/absl/synchronization/barrier.cc
third_party/abseil-cpp/absl/synchronization/blocking_counter.cc
third_party/abseil-cpp/absl/synchronization/internal/create_thread_identity.cc
third_party/abseil-cpp/absl/synchronization/internal/per_thread_sem.cc
third_party/abseil-cpp/absl/synchronization/internal/waiter.cc
third_party/abseil-cpp/absl/synchronization/mutex.cc
third_party/abseil-cpp/absl/synchronization/notification.cc
third_party/abseil-cpp/absl/time/civil_time.cc
third_party/abseil-cpp/absl/time/clock.cc
third_party/abseil-cpp/absl/time/duration.cc
third_party/abseil-cpp/absl/time/format.cc
third_party/abseil-cpp/absl/time/time.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/civil_time_detail.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/time_zone_fixed.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/time_zone_format.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/time_zone_if.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/time_zone_impl.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/time_zone_info.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/time_zone_libc.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/time_zone_lookup.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/time_zone_posix.cc
third_party/abseil-cpp/absl/time/internal/cctz/src/zone_info_source.cc
third_party/abseil-cpp/absl/types/bad_optional_access.cc
third_party/abseil-cpp/absl/types/bad_variant_access.cc
constants/appearance.cpp
constants/annotation_common.cpp
constants/font_encodings.cpp
constants/form_fields.cpp
constants/page_object.cpp
constants/stream_dict_common.cpp
constants/transparency.cpp
core/fdrm/fx_crypt.cpp
core/fdrm/fx_crypt_aes.cpp
core/fdrm/fx_crypt_sha.cpp
core/fpdfapi/cmaps/Japan1/90ms-RKSJ-H_2.cpp
core/fpdfapi/cmaps/Japan1/90ms-RKSJ-V_2.cpp
core/fpdfapi/cmaps/Japan1/90msp-RKSJ-H_2.cpp
core/fpdfapi/cmaps/Japan1/90pv-RKSJ-H_1.cpp
core/fpdfapi/cmaps/Japan1/Add-RKSJ-H_1.cpp
core/fpdfapi/cmaps/Japan1/Add-RKSJ-V_1.cpp
core/fpdfapi/cmaps/Japan1/Adobe-Japan1-UCS2_4.cpp
core/fpdfapi/cmaps/Japan1/EUC-H_1.cpp
core/fpdfapi/cmaps/Japan1/EUC-V_1.cpp
core/fpdfapi/cmaps/GB1/UniGB-UCS2-H_4.cpp
core/fpdfapi/cmaps/GB1/UniGB-UCS2-V_4.cpp
core/fpdfapi/cmaps/GB1/cmaps_gb1.cpp
core/fpdfapi/cmaps/Japan1/83pv-RKSJ-H_1.cpp
core/fpdfapi/cmaps/CNS1/Adobe-CNS1-UCS2_5.cpp
core/fpdfapi/cmaps/CNS1/B5pc-H_0.cpp
core/fpdfapi/cmaps/CNS1/B5pc-V_0.cpp
core/fpdfapi/cmaps/CNS1/CNS-EUC-H_0.cpp
core/fpdfapi/cmaps/CNS1/CNS-EUC-V_0.cpp
core/fpdfapi/cmaps/CNS1/ETen-B5-H_0.cpp
core/fpdfapi/cmaps/CNS1/ETen-B5-V_0.cpp
core/fpdfapi/cmaps/CNS1/ETenms-B5-H_0.cpp
core/fpdfapi/cmaps/CNS1/ETenms-B5-V_0.cpp
core/fpdfapi/cmaps/CNS1/HKscs-B5-H_5.cpp
core/fpdfapi/cmaps/CNS1/HKscs-B5-V_5.cpp
core/fpdfapi/cmaps/CNS1/UniCNS-UCS2-H_3.cpp
core/fpdfapi/cmaps/CNS1/UniCNS-UCS2-V_3.cpp
core/fpdfapi/cmaps/CNS1/UniCNS-UTF16-H_0.cpp
core/fpdfapi/cmaps/CNS1/cmaps_cns1.cpp
core/fpdfapi/cmaps/GB1/Adobe-GB1-UCS2_5.cpp
core/fpdfapi/cmaps/GB1/GB-EUC-H_0.cpp
core/fpdfapi/cmaps/Japan1/90msp-RKSJ-V_2.cpp
core/fpdfapi/cmaps/GB1/GB-EUC-V_0.cpp
core/fpdfapi/cmaps/GB1/GBK-EUC-H_2.cpp
core/fpdfapi/cmaps/GB1/GBK-EUC-V_2.cpp
core/fpdfapi/cmaps/GB1/GBK2K-H_5.cpp
core/fpdfapi/cmaps/GB1/GBK2K-V_5.cpp
core/fpdfapi/cmaps/GB1/GBKp-EUC-H_2.cpp
core/fpdfapi/cmaps/GB1/GBKp-EUC-V_2.cpp
core/fpdfapi/cmaps/GB1/GBpc-EUC-H_0.cpp
core/fpdfapi/cmaps/GB1/GBpc-EUC-V_0.cpp
core/fpdfapi/cmaps/Japan1/Ext-RKSJ-H_2.cpp
core/fpdfapi/cmaps/Japan1/Ext-RKSJ-V_2.cpp
core/fpdfapi/cmaps/Japan1/H_1.cpp
core/fpdfapi/cmaps/Japan1/UniJIS-UCS2-HW-H_4.cpp
core/fpdfapi/cmaps/Japan1/UniJIS-UCS2-HW-V_4.cpp
core/fpdfapi/cmaps/Japan1/UniJIS-UCS2-H_4.cpp
core/fpdfapi/cmaps/Japan1/UniJIS-UCS2-V_4.cpp
core/fpdfapi/cmaps/Japan1/V_1.cpp
core/fpdfapi/cmaps/Japan1/cmaps_japan1.cpp
core/fpdfapi/cmaps/Korea1/Adobe-Korea1-UCS2_2.cpp
core/fpdfapi/cmaps/Korea1/KSC-EUC-H_0.cpp
core/fpdfapi/cmaps/Korea1/KSC-EUC-V_0.cpp
core/fpdfapi/cmaps/Korea1/KSCms-UHC-HW-H_1.cpp
core/fpdfapi/cmaps/Korea1/KSCms-UHC-HW-V_1.cpp
core/fpdfapi/cmaps/Korea1/KSCms-UHC-H_1.cpp
core/fpdfapi/cmaps/Korea1/KSCms-UHC-V_1.cpp
core/fpdfapi/cmaps/Korea1/KSCpc-EUC-H_0.cpp
core/fpdfapi/cmaps/Korea1/UniKS-UCS2-H_1.cpp
core/fpdfapi/cmaps/Korea1/UniKS-UCS2-V_1.cpp
core/fpdfapi/cmaps/Korea1/UniKS-UTF16-H_0.cpp
core/fpdfapi/cmaps/Korea1/cmaps_korea1.cpp
core/fpdfapi/cmaps/fpdf_cmaps.cpp
core/fpdfapi/edit/cpdf_contentstream_write_utils.cpp
core/fpdfapi/edit/cpdf_creator.cpp
core/fpdfapi/edit/cpdf_pagecontentgenerator.cpp
core/fpdfapi/edit/cpdf_pagecontentmanager.cpp
core/fpdfapi/edit/cpdf_stringarchivestream.cpp
core/fpdfapi/font/cfx_cttgsubtable.cpp
core/fpdfapi/font/cfx_stockfontarray.cpp
core/fpdfapi/font/cpdf_cid2unicodemap.cpp
core/fpdfapi/font/cpdf_cidfont.cpp
core/fpdfapi/font/cpdf_cmap.cpp
core/fpdfapi/font/cpdf_cmapparser.cpp
core/fpdfapi/font/cpdf_font.cpp
core/fpdfapi/font/cpdf_fontencoding.cpp
core/fpdfapi/font/cpdf_fontglobals.cpp
core/fpdfapi/font/cpdf_simplefont.cpp
core/fpdfapi/font/cpdf_tounicodemap.cpp
core/fpdfapi/font/cpdf_truetypefont.cpp
core/fpdfapi/font/cpdf_type1font.cpp
core/fpdfapi/font/cpdf_type3char.cpp
core/fpdfapi/font/cpdf_type3font.cpp
core/fpdfapi/page/cpdf_page.cpp
core/fpdfapi/page/cpdf_pagemodule.cpp
core/fpdfapi/page/cpdf_pageobject.cpp
core/fpdfapi/page/cpdf_pageobjectholder.cpp
core/fpdfapi/page/cpdf_path.cpp
core/fpdfapi/page/cpdf_pathobject.cpp
core/fpdfapi/page/cpdf_pattern.cpp
core/fpdfapi/page/cpdf_patterncs.cpp
core/fpdfapi/page/cpdf_psengine.cpp
core/fpdfapi/page/cpdf_psfunc.cpp
core/fpdfapi/page/cpdf_sampledfunc.cpp
core/fpdfapi/page/cpdf_shadingobject.cpp
core/fpdfapi/page/cpdf_shadingpattern.cpp
core/fpdfapi/page/cpdf_stitchfunc.cpp
core/fpdfapi/page/cpdf_graphicstates.cpp
core/fpdfapi/page/cpdf_iccprofile.cpp
core/fpdfapi/page/cpdf_image.cpp
core/fpdfapi/page/cpdf_imageobject.cpp
core/fpdfapi/page/cpdf_indexedcs.cpp
core/fpdfapi/page/cpdf_meshstream.cpp
core/fpdfapi/page/cpdf_occontext.cpp
core/fpdfapi/page/cpdf_allstates.cpp
core/fpdfapi/page/cpdf_annotcontext.cpp
core/fpdfapi/page/cpdf_basedcs.cpp
core/fpdfapi/page/cpdf_clippath.cpp
core/fpdfapi/page/cpdf_color.cpp
core/fpdfapi/page/cpdf_colorspace.cpp
core/fpdfapi/page/cpdf_colorstate.cpp
core/fpdfapi/page/cpdf_contentmarkitem.cpp
core/fpdfapi/page/cpdf_contentmarks.cpp
core/fpdfapi/page/cpdf_contentparser.cpp
core/fpdfapi/page/cpdf_devicecs.cpp
core/fpdfapi/page/cpdf_dib.cpp
core/fpdfapi/page/cpdf_docpagedata.cpp
core/fpdfapi/page/cpdf_expintfunc.cpp
core/fpdfapi/page/cpdf_form.cpp
core/fpdfapi/page/cpdf_formobject.cpp
core/fpdfapi/page/cpdf_function.cpp
core/fpdfapi/page/cpdf_generalstate.cpp
core/fpdfapi/page/cpdf_streamcontentparser.cpp
core/fpdfapi/page/cpdf_streamparser.cpp
core/fpdfapi/page/cpdf_textobject.cpp
core/fpdfapi/page/cpdf_textstate.cpp
core/fpdfapi/page/cpdf_tilingpattern.cpp
core/fpdfapi/page/cpdf_transferfunc.cpp
core/fpdfapi/page/cpdf_transferfuncdib.cpp
core/fpdfapi/page/cpdf_transparency.cpp
core/fpdfapi/parser/cpdf_flateencoder.cpp
core/fpdfapi/parser/cpdf_hint_tables.cpp
core/fpdfapi/parser/cpdf_indirect_object_holder.cpp
core/fpdfapi/parser/cpdf_linearized_header.cpp
core/fpdfapi/parser/cpdf_name.cpp
core/fpdfapi/parser/cpdf_null.cpp
core/fpdfapi/parser/cpdf_number.cpp
core/fpdfapi/parser/cpdf_object.cpp
core/fpdfapi/parser/cpdf_object_avail.cpp
core/fpdfapi/parser/cpdf_object_stream.cpp
core/fpdfapi/parser/cpdf_object_walker.cpp
core/fpdfapi/parser/cpdf_page_object_avail.cpp
core/fpdfapi/parser/cpdf_parser.cpp
core/fpdfapi/parser/cpdf_read_validator.cpp
core/fpdfapi/parser/cpdf_reference.cpp
core/fpdfapi/parser/cpdf_security_handler.cpp
core/fpdfapi/parser/cpdf_simple_parser.cpp
core/fpdfapi/parser/cpdf_stream.cpp
core/fpdfapi/parser/cpdf_stream_acc.cpp
core/fpdfapi/parser/cpdf_string.cpp
core/fpdfapi/parser/cpdf_syntax_parser.cpp
core/fpdfapi/parser/fpdf_parser_decode.cpp
core/fpdfapi/parser/fpdf_parser_utility.cpp
core/fpdfapi/parser/cfdf_document.cpp
core/fpdfapi/parser/cpdf_array.cpp
core/fpdfapi/parser/cpdf_boolean.cpp
core/fpdfapi/parser/cpdf_cross_ref_avail.cpp
core/fpdfapi/parser/cpdf_cross_ref_table.cpp
core/fpdfapi/parser/cpdf_crypto_handler.cpp
core/fpdfapi/parser/cpdf_data_avail.cpp
core/fpdfapi/parser/cpdf_dictionary.cpp
core/fpdfapi/parser/cpdf_document.cpp
core/fpdfapi/parser/cpdf_encryptor.cpp
core/fpdfapi/render/charposlist.cpp
core/fpdfapi/render/cpdf_devicebuffer.cpp
core/fpdfapi/render/cpdf_docrenderdata.cpp
core/fpdfapi/render/cpdf_imageloader.cpp
core/fpdfapi/render/cpdf_imagerenderer.cpp
core/fpdfapi/render/cpdf_pagerendercache.cpp
core/fpdfapi/render/cpdf_pagerendercontext.cpp
core/fpdfapi/render/cpdf_progressiverenderer.cpp
core/fpdfapi/render/cpdf_rendercontext.cpp
core/fpdfapi/render/cpdf_renderoptions.cpp
core/fpdfapi/render/cpdf_rendershading.cpp
core/fpdfapi/render/cpdf_renderstatus.cpp
core/fpdfapi/render/cpdf_rendertiling.cpp
core/fpdfapi/render/cpdf_scaledrenderbuffer.cpp
$<${WIN}:core/fpdfapi/render/cpdf_windowsrenderdevice.cpp>
core/fpdfapi/render/cpdf_textrenderer.cpp
core/fpdfapi/render/cpdf_type3cache.cpp
core/fpdfapi/render/cpdf_type3glyphmap.cpp
core/fpdfdoc/cpvt_fontmap.cpp
core/fpdfdoc/cpvt_section.cpp
core/fpdfdoc/cpvt_variabletext.cpp
core/fpdfdoc/cpvt_wordinfo.cpp

=== contrib/build_ffmpeg/packaging/PKGBUILD ===
# Maintainer: Pablo Martin <pm@mega.nz>
pkgname=ffmpeg-mega
pkgver=512.0
pkgrel=`cat MEGA_BUILD_ID || echo "1"`
epoch=
pkgdesc="TODO"
arch=('i686' 'x86_64')
url="TODO"
license=() #TODO
groups=()
depends=('glibc' 'gcc-libs')
makedepends=('unzip' 'wget' 'ca-certificates' 'zlib' 'extra-cmake-modules')
checkdepends=()
optdepends=()
provides=("ffmpeg-mega=${pkgver}")
conflicts=()
replaces=()
backup=()
options=()
#~ install=()
changelog= #TODO
source=("./ffmpeg-mega_${pkgver}.tar.gz"
)
noextract=()
md5sums=('SKIP')
validpgpkeys=()

prepare() {
	cd "$pkgname-$pkgver"
}

build() {
	cd "$pkgname-$pkgver"
	bash -x ./build_minimum.sh
}

check() {
	cd "$pkgname-$pkgver"
}

package() {
	cd "$pkgname-$pkgver"
	for i in `find target/lib -name "lib*a" -type f`; do install -D $i $pkgdir/usr/lib/${i/target\/lib\//}; done
	for i in `find target/include -type f | grep -v openssl `; do install -D -m 444 $i $pkgdir/usr/include/ffmpeg-mega/${i/target\/include\//}; done
}

=== contrib/build_pdfium/packaging/PKGBUILD ===
# Maintainer: Pablo Martin <pm@mega.nz>
pkgname=pdfium-mega
pkgver=5247.0
pkgrel=1
epoch=
pkgdesc="TODO"
arch=('x86_64')
url="TODO"
license=() #TODO
groups=()
depends=('glibc' 'gcc-libs')
makedepends=('unzip' 'ca-certificates' 'python3' 'rsync' 'git')
checkdepends=()
optdepends=()
provides=("pdfium-mega=${pkgver}")
conflicts=()
replaces=()
backup=()
options=()
#~ install=()
changelog= #TODO
source=("./pdfium-mega_${pkgver}.tar.gz"
)
noextract=()
md5sums=('SKIP')
validpgpkeys=()

prepare() {
    cd "$pkgname-$pkgver"
}

build() {
    cd "$pkgname-$pkgver"
    ./third_party/depot_tools/ninja ${BUILD_PARALLEL_JOBS} -C out pdfium
    #clean all unrequired stuff
    rm -rf `ls | grep -v "out\|public\|pdfium.pc.in"`
}

check() {
    cd "$pkgname-$pkgver"
}

package() {
    cd "$pkgname-$pkgver"
    for i in `find out/obj -name "libpdfium.a" -type f`; do install -D $i $pkgdir/usr/lib/${i/out\/obj\//}; done
    for i in `find public -type f`; do install -D -m 444 $i $pkgdir/usr/include/${i/public\//}; done
    sed -i "s#@PREFIX@#/usr#" pdfium.pc.in
    install -D -m 644 pdfium.pc.in $pkgdir/usr/lib/pkgconfig/pdfium.pc
}
